#include "Eigen/Dense"
#include <iostream>
using namespace std;

int main() {
  using MT=Eigen::Matrix<float,3,3>;
  using VT=Eigen::Matrix<float,3,1>;
  MT A=MT::Random(); A=A*A.transpose(); 
  cout << "A=" << endl << A << endl;
  VT b=VT::Random();
  cout << "b^T=" << b.transpose() << endl;
  Eigen::LLT<MT> LLT(A);
  MT L=LLT.matrixLLT().triangularView<Eigen::Lower>();
  cout << "L=" << endl << L << endl;
  cout << "L*L^T=" << endl << L*L.transpose() << endl;
  VT x=LLT.solve(b);
  cout << "x^T=" << x.transpose() << endl;
  cout << "(A*x)^T=" << (A*x).transpose() << endl;
  return 0;
}
