#include "Eigen/Dense"
#include <iostream>
using namespace std;

int main() {
  using MT=Eigen::Matrix<float,3,3>;
  using VT=Eigen::Matrix<float,3,1>;
  MT A=MT::Random();
  cout << "A=" << endl << A << endl;
  VT b=VT::Random();
  cout << "b^T=" << b.transpose() << endl;
  Eigen::PartialPivLU<MT> LU(A);
  MT L=LU.matrixLU().triangularView<Eigen::StrictlyLower>();
  L+=MT::Identity();
  MT R=LU.matrixLU().triangularView<Eigen::Upper>();
  MT P=LU.permutationP();
  cout << "P=" << endl << P << endl;
  cout << "L" << endl << L << endl;
  cout << "R" << endl << R << endl;
  cout << "P*L*R" << endl << P*L*R << endl;
  VT x=LU.solve(b);
  cout << "x^T=" << x.transpose() << endl;
  cout << "(A*x)^T=" << (A*x).transpose() << endl;
  return 0;
}


