#include "Eigen/Dense"
#include <iostream>
using namespace std;

int main() {
  using MT=Eigen::Matrix<float,3,3>;
  using VT=Eigen::Matrix<float,3,1>;
  MT A=MT::Random();
  cout << "A=" << endl << A << endl;
  VT b=VT::Random();
  cout << "b^T=" << b.transpose() << endl;
  Eigen::HouseholderQR<MT> QR(A);
  MT Q=QR.householderQ();
  MT R=QR.matrixQR().triangularView<Eigen::Upper>();
  cout << "Q=" << endl << Q << endl;
  cout << "R=" << endl << R << endl;
  cout << "Q*R=" << endl << Q*R << endl;
  VT x=QR.solve(b);
  std::cout << "x^T=" << x.transpose() << std::endl;
  std::cout << "(A*x)^T=" << (A*x).transpose() << std::endl;
  return 0;
}
